; ==================================================
; = eLiB16 Command Line Example                    =
; = (C) 1999 Teraphy and Embla                     =
; =                                                =
; = Demonstrates how to use GetNrOfArgs function   =
; = and GetCommandLine function. This tool simply  =
; = prints all command line arguments, one by one  =
; = to screen. Note that arguments in quotation    =
; = marks are threated as one. This can be usefull =
; = when handling long file names.                 =
; ==================================================

.model		small, stdcall
.stack		256
.386

include         \elib16\elib16.inc
includelib      \elib16\elib16.lib

.data

szBuffer	db 40 dup (?)

.code

Start:

	; Init Command Line
	invoke	InitCommandLine

	; Init Segments
	mov	ax,@data
	mov	ds,ax
	mov	es,ax

	; Print Intro Message
	PrintM	"eLiB - Command Line Example", CrLf, \
		"(C) 1999 Teraphy and Embla"

	; Get Nr of Arguments
	invoke	GetNrOfArgs
	
	; Unmatching Quote Marks?
	.IF ax == CLINE_ERRQUOTE
		PrintM	CrLf,"Error: Unmatching Quote Marks"
		.EXIT	-1
	.ENDIF

	; Print Message
	PrintM	CrLf,"Nr of Args : "
	
	; Convert to String
	invoke	ValToStr, offset szBuffer+39, ax, 10, NULL

	; Print Nr of Args
	invoke	Print, ax

	; Get Nr Of Args
	invoke	GetNrOfArgs

	; Display Arguments
	xor	bx,bx
	mov	cx,ax
	.WHILE bx != cx
		; Increase BX
		inc	bx
		; Print Message
		PrintM	CrLf, "Arg "
		; Convert ArgNr to String
		invoke	ValToStr, offset szBuffer+39, bx, 10, 2
		; Print Arg Nr
		invoke	Print, ax
		; Print Message
		PrintM	"     : "
		; Get Command Line Arg
                invoke	GetCommandLine, offset szBuffer, bl
		; Print Argument
		invoke	Print, offset szBuffer
	.ENDW

	; Exit Program
        .EXIT	0

end Start
