; ==================================================
; = eLiB16 Calculator Example                      =
; = (C) 1999 Teraphy and Embla                     =
; =                                                =
; = Demonstrates eLiB's Display features. This     =
; = is a simple calculator. The display features   =
; = includes DOS font and ANSI display.            =
; ==================================================

.model		small, stdcall
.stack		256
.386

include         \elib16\elib16.inc
includelib      \elib16\elib16.lib

.data
include		ansi1.inc
include		ansi2.inc
include		font.inc

dValue		dd 0
bLast		db 0
dSaveValue	dd 0
wKey		dw 0
szBuffer	db 15 dup (?)

.code

Start:

	; Initiera Segment
        mov     ax,@data
        mov     ds,ax
        mov     es,ax

	; Save Screen Layout
	invoke	SaveLayout

	; Set Textmode
	invoke	SetTextMode, 25

	; Set Font
	invoke	SetFont, offset Font

	; Turn off Cursor
	invoke	SetCursorType, CUR_NONE

	; Main Loop (Until Alt-X is pressed)
	.WHILE wKey != 2D00h

		; Display Ansis
                invoke  DisplayAnsi, offset Ansi1, 0, 0, (Ansi1Size/2)
                invoke  DisplayAnsi, offset Ansi2, 0, 24, (Ansi2Size/2)

		; Set Cursor Posistion
		invoke	SetCursorPos, 48, 3

		; Print Current Number
		invoke	ValToStr, offset szBuffer+14, dValue, 10, NULL
		invoke	CPrintEx, BLACK, LIGHTMAGENTA, ax, TEXT_RIGHT

		; Read KeyPress
		invoke	ReadKey
		mov	wKey, ax
		
		; Check Key Press
		.IF (al >= '0') && (al <= '9')
			; Number pressed. Calculate new value
			and	eax,0FFh
			sub	al, '0'
			mov	ebx,dValue
			imul	ebx,10
			add	ebx,eax
			mov	dValue,ebx
		.ELSEIF (al == '+') || (al == '-') || (al == '/') || (al == '*')
			; Math Char pressed. Prepare for Calculation
			mov	bLast,al
			mov	ebx,dValue
			mov	dSaveValue,ebx
			mov	dValue,0
		.ELSEIF ax == KEY_ENTER
			; Sum Key pressed. Calculate.
			mov	ebx,dValue
			.IF bLast == '+'
				add	dSaveValue,ebx
			.ELSEIF bLast == '-'
				sub	dSaveValue,ebx
			.ELSEIF bLast == '*'
				mov	eax,dSaveValue
				mul	ebx
				mov	dSaveValue,eax
			.ELSEIF bLast == '/'
				mov	eax,dSaveValue
				xor	edx,edx
				idiv	ebx
				mov	dSaveValue,eax
			.ENDIF
			.IF bLast != 0
				mov	eax,dSaveValue
				mov	dValue,eax
				mov	bLast,0
			.ENDIF
		.ELSEIF ax == KEY_ESC
			; ESC Key Pressed. Set values to Zero
			mov	dValue,0
			mov	dSaveValue,0
			mov	bLast,0
		.ENDIF

	.ENDW

	; Restore Screen Layout
	invoke	RestoreLayout

	; Exit
        .EXIT   0

end Start
