; ==================================================
; = eLiB16 COM File Encryptor                      =
; = (C) 1999 Teraphy and Embla                     =
; =                                                =
; = Demonstrates some more file techniques.        =
; = This lets you encrypt a com file, leaving      =
; = it executeable.                                =
; ==================================================

.model		small, stdcall
.stack		256
.386

include         \elib16\elib16.inc
includelib      \elib16\elib16.lib

.data

; ------ Append Code --------------------------------------------------
ComTopCode	Label Byte
	DB '----------------------eLiB----------------------',0,0
	DB 0B8h		; mov ax, ????
Bottom	DW 0
	jmp	ax
ComTopCodeSize	EQU $-ComTopCode

ComDownCode	Label Byte
	push	100h
	mov	si,ComTopCodeSize+100h
	mov	di,100h
	DB 0B9h		; mov cx, ????
FSize	DW 0
@@:
	lodsb
	xor	al,'e'
	stosb
	loop	@B
	ret
ComDownCodeSize	EQU $-ComDownCode

; ------ Program Data -------------------------------------------------
szTemp		db 'c:\',0,13 dup (?)
szFile		db 13 dup (?)
hInFile		dw ?
hOutFile	dw ?
ReadBuffer	db 128 dup (?)

.code

; ------ Main Program -------------------------------------------------
Start:

	; Init Command Line
	invoke	InitCommandLine

	; Init Segments
        mov     ax,@data
        mov     ds,ax
        mov     es,ax

	; Print String
	PrintM	"eLiB - COM Encryptor", CrLf, \
		"(C) 1999 Teraphy and Embla"

	; Get Filename
	invoke	GetCommandLine, offset szFile, 1
	.IF ax != CLINE_OK
		PrintM	CrLf, "Error: No File Specified"
		.EXIT	-1
	.ENDIF

	; Open Input File
	invoke	FileOpen, offset szFile, READ_ONLY
	.IF ax == ERROR
		PrintM	CrLf, "Error: Could'nt Open File"
		.EXIT	-1
	.ENDIF
	mov	hInFile,ax

	; Create Temporary File
	invoke	FileTempCreate, offset szTemp, ATTR_NORMAL
	.IF ax == ERROR
		invoke	FileClose, hInFile
		PrintM	CrLf, "Error: Could'nt Create Temp File"
		.EXIT	-1
	.ENDIF
	mov	hOutFile, ax

	; Get File Size and Save Needed Values
	invoke	FileGetSize, hInFile
	mov	FSize, ax
	add	ax,ComTopCodeSize+100h
	mov	Bottom, ax

	; Write New Start of Com File
	invoke	FileWrite, hOutFile, offset ComTopCode, ComTopCodeSize

	; Encryption Loop
	xor	bx,bx
	.WHILE bx != FSize
		; Read Input File
		invoke	FileRead, hInFile, offset ReadBuffer, 128
		; Update BX
		add	bx,ax
		; Encrypt Buffer
		mov	cx,ax
		mov	si,offset ReadBuffer
		mov	di,si
		push	cx
		@@:
			lodsb
			xor	al,'e'
			stosb
			loop	@B
		pop	cx
		; Write Buffer to Output File
		invoke	FileWrite, hOutFile, offset ReadBuffer, cx
	.ENDW

	; Write New End of Com File
	invoke	FileWrite, hOutFile, offset ComDownCode, ComDownCodeSize

	; Close Files
	invoke	FileClose, hInFile
	invoke	FileClose, hOutFile

	; Delete Input File
	invoke	FileDelete, offset szFile

	; Copy Temp
	invoke	FileCopy, offset szTemp, offset szFile	

	; Delete Temp File
	invoke	FileDelete, offset szTemp

	; Print String
	PrintM	CrLf, "Done: File Sucessfully Encrypted"

	; Exit Program
        .EXIT   0

end Start
