; ==================================================
; = eLiB16 Byte Patch Example                      =
; = (C) 1999 Teraphy and Embla                     =
; =                                                =
; = Demonstrates File I/O Functions. This is a     =
; = simple byte patch with filesize check.         =
; ==================================================

.model		small, stdcall
.stack		256
.386

include         \elib16\elib16.inc
includelib      \elib16\elib16.lib

.data

szFile		db 'Target.exe',0	; <- Target File
FileSize	EQU 5			; <- Filesize
PatchData	dd 0			; <- Offset
		db 090h			; <- Byte to write
		dd 1			; <- Offset
		db 090h			; <- Byte to write
					; just add more of theese
					; to patch more offsets.
PatchSize	EQU ($-PatchData) / 5

hFile		dw ?
bTemp		db ?

.code

Start:

	; Init Segments
        mov     ax,@data
        mov     ds,ax
        mov     es,ax

	; Print String
	PrintM	"eLiB - Byte Patch Example",CrLf, \
		"(C) 1999 Teraphy and Embla"

	; Open File
	invoke	FileOpen, offset szFile, WRITE_ONLY
	.IF ax == ERROR
		PrintM	CrLf, "Error: Target File Not Found"
		.EXIT	-1
	.ENDIF
	mov	hFile, ax

	; Check File Size
	invoke	FileGetSize, hFile
	.IF eax != FileSize
		PrintM	CrLf, "Error: Incorrect Filesize"
		.EXIT	-1
	.ENDIF

	; Patch File
	mov	si, offset PatchData
	xor	bx, bx
	.WHILE bx != PatchSize
		inc	bx
		; Move File Pointer
		lodsd
		invoke	FileMovePtr, hFile, eax, FILE_BEGIN
		; Write New Byte
		lodsb
		mov	bTemp, al
		invoke	FileWrite, hFile, offset bTemp, 1
	.ENDW

	; Close File
	invoke	FileClose, hFile

	; Print String
	PrintM	CrLf, "Done: File Sucessfully Patched"

	; Exit
        .EXIT   0

end Start
