; ******************************
; * eLiB16 v1.0 - Include File *
; * (C) 1999 Teraphy and Embla *
; ******************************


; ==============================
; === Functions ================
; ==============================

; I/O
Print           PROTO :WORD
PrintEx		PROTO :WORD, :BYTE
CPrint		PROTO :BYTE, :BYTE, :WORD
CPrintEx	PROTO :BYTE, :BYTE, :WORD, :BYTE
Input           PROTO :WORD
InitCommandLine	PROTO
GetNrOfArgs	PROTO
GetCommandLine	PROTO :WORD, :BYTE
ReadKey		PROTO
; File I/O
FileOpen	PROTO :WORD, :BYTE
FileCreate	PROTO :WORD, :WORD
FileDelete	PROTO :WORD
FileCopy	PROTO :WORD, :WORD
FileClose	PROTO :WORD
FileRead	PROTO :WORD, :WORD, :WORD
FileWrite	PROTO :WORD, :WORD, :WORD
FileMovePtr	PROTO :WORD, :DWORD, :BYTE
FileGetSize	PROTO :WORD
FileTempCreate	PROTO :WORD, :WORD
; Convertion
ValToStr        PROTO :WORD, :DWORD, :BYTE, :BYTE
StrToVal        PROTO :WORD, :BYTE
; String
StrUpr          PROTO :WORD, :WORD
StrLwr          PROTO :WORD, :WORD
StrLen          PROTO :WORD
StrCopy		PROTO :WORD, :WORD
; Display
ClrScr		PROTO :BYTE
SaveScreen	PROTO :BYTE
RestoreScreen	PROTO :BYTE
GetCursor	PROTO
SetCursorType	PROTO :WORD
SetCursorPos	PROTO :BYTE, :BYTE
SetFont		PROTO :WORD
DisplayAnsi	PROTO :WORD, :BYTE, :BYTE, :WORD
GetTextMode	PROTO
SetTextMode	PROTO :BYTE
SaveLayout	PROTO
RestoreLayout	PROTO

; ==============================
; = Macros =====================
; ==============================

PrintM		MACRO sText:VARARG
		LOCAL Temp, Label
	jmp Label
	Temp	db sText,0
Label:
	push	ds
	push	cs
	pop	ds
	invoke	Print, offset Temp
	pop	ds
		ENDM

CPrintM         MACRO bBack,bFore,sText:VARARG
                LOCAL Temp, Label
	jmp Label
	Temp	db sText,0
Label:
	push	ds
	push	cs
	pop	ds
        invoke	CPrint, bBack, bFore, offset Temp
	pop	ds
		ENDM

DataM		MACRO Name,sText:VARARG
	.data
	Name	db sText
	.code
		ENDM

LoWordM		MACRO Reg
	and	reg, 0FFFFh
		ENDM

HiWordM		MACRO Reg
	shr	reg, 16
		ENDM

BeepM		MACRO
	push	ax
	mov	al,7
	int	29h
	pop	ax
		ENDM

; ==============================
; === Constants ================
; ==============================

; Standard
NULL		EQU 0
ERROR		EQU -1
CrLf		EQU <13,10>
; Command Line
CLINE_OK	EQU 0
CLINE_NOTAIL	EQU 1
CLINE_ERRQUOTE	EQU -1
CLINE_NOARG	EQU 3
; SetCursor
CUR_STANDARD	EQU 0D0Eh
CUR_MEDIUM	EQU 0D1Fh
CUR_LARGE	EQU 001Fh
CUR_NONE	EQU 2000h
; ReadKey
KEY_ENTER	EQU 1C0Dh
KEY_ESC         EQU 011Bh
KEY_TAB         EQU 0F09h
KEY_DOWN        EQU 5000h
KEY_UP          EQU 4800h
KEY_PAGEDOWN    EQU 5100h
KEY_PAGEUP      EQU 4900h
KEY_RIGHT       EQU 4D00h
KEY_LEFT        EQU 4B00h
KEY_HOME	EQU 4700h
KEY_END		EQU 4F00h
KEY_F1          EQU 3B00h
KEY_F2          EQU 3C00h
KEY_F3          EQU 3D00h
KEY_F4          EQU 3E00h
KEY_F5          EQU 3F00h
KEY_F6		EQU 4000h
KEY_F7		EQU 4100h
KEY_F8		EQU 4200h
KEY_F9		EQU 4300h
KEY_F10		EQU 4400h
KEY_F11		EQU 8500h
KEY_F12		EQU 8600h
; File Attributes
ATTR_NORMAL	EQU 0
ATTR_READONLY	EQU 1b
ATTR_HIDDEN	EQU 10b
ATTR_SYSTEM	EQU 100b
; File Modes
READ_ONLY	EQU 0
WRITE_ONLY	EQU 1
READWRITE	EQU 2
; Move Ptr
FILE_BEGIN	EQU 0
CURRENT_POS	EQU 1
FILE_END	EQU 2
; Colors
BLACK		EQU 0
BLUE		EQU 1
GREEN		EQU 2
CYAN		EQU 3
RED		EQU 4
MAGENTA		EQU 5
BROWN		EQU 6
LIGHTGREY	EQU 7
LIGHTGRAY	EQU 7
GRAY		EQU 8
GREY		EQU 8
LIGHTBLUE	EQU 9
LIGHTGREEN	EQU 10
LIGHTCYAN	EQU 11
LIGHTRED	EQU 12
LIGHTMAGENTA	EQU 13
YELLOW		EQU 14
WHITE		EQU 15
; PrintEx/CPrintEx
TEXT_LEFT	EQU 0
TEXT_RIGHT	EQU 1
TEXT_CENTER	EQU 2