; ==================================================
; = eLiB32 Command Line Example                    =
; = (C) 1999 Teraphy                               =
; =                                                =
; = Demonstrates how to use GetNrOfArgs function   =
; = and GetCLineArg function. This tool simply     =
; = prints all command line arguments, one by one  =
; = to screen. Note that arguments in quotation    =
; = marks are threated as one. This can be usefull =
; = when handling long file names.                 =
; ==================================================

.486
.model		flat, stdcall

; eLiB32 Includes
include		elib32.inc
includelib	elib32.lib
; Windows Includes
include		windows.inc
include		kernel32.inc
include		user32.inc
includelib	kernel32.lib
includelib	user32.lib

.data?

szBuffer	db 40 dup (?)

.code

Start:
	
	; Print Intro Message
	PrintM	"eLiB - Command Line Example", CrLf, \
		"(C) 1999 Teraphy"

	; Get Nr of Arguments
	invoke	GetNrOfArgs
	
	; Unmatching Quote Marks?
	.IF ax == CLINE_ERRQUOTE
		PrintM	CrLf,"Error: Unmatching Quote Marks"
		Exit	-1
	.ENDIF

	; Print Message
	PrintFM	<CrLf,"Nr of Args : %lu">, eax
	
	; Get Nr Of Args
	invoke	GetNrOfArgs

	; Display Arguments
	xor	ebx,ebx
	mov	ecx,eax
	.WHILE ebx != ecx
		; Increase EBX
		inc	ebx
		; Print Message
		PrintFM	<CrLf, "Arg %.2lu     : ">, ebx
		; Get Command Line Arg
                invoke	GetCLineArg, addr szBuffer, ebx
		; Print Argument
		invoke	Print, addr szBuffer
	.ENDW

	; Exit Program
	Exit	0

end Start
